Unit AET3C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AA02C_p, UTAE12_p;

procedure AET3C(NM :Integer; N :Integer; var AR :Array of Real;
                var AI :Array of Real; var WR :Array of Real;
                var WI :Array of Real; var SELECT :Array of Boolean;
                MM :Integer; var M :Integer; var ZR :Array of Real;
                var ZI :Array of Real; var RM1 :Array of Real;
                var RM2 :Array of Real; var RV1 :Array of Real;
                var RV2 :Array of Real; var IERR :Integer);

implementation

procedure AET3C(NM :Integer; N :Integer; var AR :Array of Real;
                var AI :Array of Real; var WR :Array of Real;
                var WI :Array of Real; var SELECT :Array of Boolean;
                MM :Integer; var M :Integer; var ZR :Array of Real;
                var ZI :Array of Real; var RM1 :Array of Real;
                var RM2 :Array of Real; var RV1 :Array of Real;
                var RV2 :Array of Real; var IERR :Integer);
var
I,II,IP1,ITS,J,K,KM1,MP,S,UK :Integer;
EPS3,GROWTO,ILAMBD,MACHEP,NORM,NORMV,RLAMBD,UKROOT,X,Y :Real;
LOG :Boolean;
const
SYS051 :Real = 1.192093E-07;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320;
{  -  FORTRAN }
function AA01C(X: Real; Y: Real): Real;
begin
Result := Cabs(Cmplx(X,Y));
end;
{   - }
begin
MACHEP := SYS051;
IERR := 0;
UK := 0;
S := 1;
for K:=1 to N do
 begin
  LOG := ( not  SELECT[K-1] );
  if ( LOG ) 
   then goto _300;
  if ( S >  MM ) 
   then goto _310;
  if ( UK >=  K ) 
   then goto _50;
{      POBEPKA HA PACEEHE }
  for UK:=K to N do
   begin
    if ( UK =  N ) 
     then goto _20;
    if ( AR[(UK+0)+(UK-1)*NM] =  0.0 ) and (  AI[(UK+0)+(UK-1)*NM]
 =  0.0 ) 
     then goto _20;
_10:
   end;
{      BCEHE HOPM ABHOO MHOPA PAMEPHOCT UK*UK }
{      MATP XECCEHEPA }
_20:
  NORM := 0.0;
  MP := 1;
  for I:=1 to UK do
   begin
    X := 0.0;
    for J:=MP to UK do
     begin
      X := X + AA01C(AR[(I-1)+(J-1)*NM],AI[(I-1)+(J-1)*NM]);
_30:
     end;
    if ( X >  NORM ) 
     then NORM := X;
    MP := I;
_40:
   end;
{      EPS3-BEHA  AMEH MAOO BEYEO EMEHTA; }
{      KE C.H.PAETC HA BEHY 2*EPS3 }
  EPS3 := MACHEP*NORM;
  if ( EPS3 <=  MACHEP ) 
   then EPS3 := MACHEP;
{      GROWTO-AKTOP POCTA }
  UKROOT := Sqrt((UK));
  GROWTO := 1.0E-1/UKROOT;
_50:
  RLAMBD := WR[K-1];
  ILAMBD := WI[K-1];
  if ( K =  1 ) 
   then goto _90;
  KM1 := K - 1;
  goto _70;
{      BOMYEHE C.H.,EC OHO KO K PAHEE BEHHM }
_60:
  RLAMBD := RLAMBD + 2*EPS3;
{      I=K-1,1,-1 }
_70:
  for II:=1 to KM1 do
   begin
    I := K - II;
    if ( SELECT[I-1] ) and (  Abs(WR[I-1] - RLAMBD) <  2.0*
         EPS3 ) and (  Abs(WI[I-1] - ILAMBD) <  2.0*EPS3 )
     then goto _60;
_80:
   end;
  WR[K-1] := RLAMBD;
{      OPM-E MATP XECCEHEPA(AR,AI)-(RLAMBD,ILAMBD)*I }
{       KOMEKCHOO HAAHOO BEKTOPA }
_90:
  MP := 1;
  for I:=1 to UK do
   begin
    for J:=MP to UK do
     begin
      RM1[(I-1)+(J-1)*N] := AR[(I-1)+(J-1)*NM];
      RM2[(I-1)+(J-1)*N] := AI[(I-1)+(J-1)*NM];
_100:
     end;
    RM1[(I-1)+(I-1)*N] := RM1[(I-1)+(I-1)*N] - RLAMBD;
    RM2[(I-1)+(I-1)*N] := RM2[(I-1)+(I-1)*N] - ILAMBD;
    MP := I;
    RV1[I-1] := EPS3;
_110:
   end;
{      BEEHE K TPEY.OPME METOOM AYCCA C EPECTAHOBKAM; }
{      MA BEY EMEHT AMEHETC HA EPS3 }
  if ( UK =  1 ) 
   then goto _160;
  for I:=2 to UK do
   begin
    MP := I - 1;
    if ( AA01C(RM1[(I-1)+(MP-1)*N],RM2[(I-1)+(MP-1)*N]) <=  AA01C(RM1[(MP-1)+(
         MP-1)*N],RM2[(MP-1)+(MP-1)*N]) ) 
     then goto _130;
    for J:=MP to UK do
     begin
      Y := RM1[(I-1)+(J-1)*N];
      RM1[(I-1)+(J-1)*N] := RM1[(MP-1)+(J-1)*N];
      RM1[(MP-1)+(J-1)*N] := Y;
      Y := RM2[(I-1)+(J-1)*N];
      RM2[(I-1)+(J-1)*N] := RM2[(MP-1)+(J-1)*N];
      RM2[(MP-1)+(J-1)*N] := Y;
_120:
     end;
_130:
    if ( Abs(RM1[(MP-1)+(MP-1)*N]) <  EPS3 ) and (  Abs(RM2[(MP-1)+(
         MP-1)*N]) <  EPS3 ) 
     then RM1[(MP-1)+(MP-1)*N] := EPS3;
    AA02C(RM1[(I-1)+(MP-1)*N],RM2[(I-1)+(MP-1)*N],RM1[(MP-1)+(MP-1)*N],RM2[(MP-1)+(
         MP-1)*N],X,Y);
    if ( X =  0.0 ) and (  Y =  0.0 ) 
     then goto _150;
    for J:=I to UK do
     begin
      RM1[(I-1)+(J-1)*N] := RM1[(I-1)+(J-1)*N] - X*RM1[(MP-1)+(J-1)*N] + Y*
    RM2[(MP-1)+(J-1)*N];
      RM2[(I-1)+(J-1)*N] := RM2[(I-1)+(J-1)*N] - X*RM2[(MP-1)+(J-1)*N] - Y*
    RM1[(MP-1)+(J-1)*N];
_140:
     end;
_150:
   end;
_160:
  if ( Abs(RM1[(UK-1)+(UK-1)*N]) <  EPS3 ) and (  Abs(RM2[(UK-1)+(UK-1)*N])
 <  EPS3 ) 
   then RM1[(UK-1)+(UK-1)*N] := EPS3;
  ITS := 0;
{      OPATHA OCTAHOBKA }
{      I=UK,1,-1 }
_170:
  for II:=1 to UK do
   begin
    I := UK + 1 - II;
    X := RV1[I-1];
    Y := 0.0;
    if ( I =  UK ) 
     then goto _190;
    IP1 := I + 1;
    for J:=IP1 to UK do
     begin
      X := X - RM1[(I-1)+(J-1)*N]*RV1[J-1] + RM2[(I-1)+(J-1)*N]*RV2[J-1];
      Y := Y - RM1[(I-1)+(J-1)*N]*RV2[J-1] - RM2[(I-1)+(J-1)*N]*RV1[J-1];
_180:
     end;
_190:
    AA02C(X,Y,RM1[(I-1)+(I-1)*N],RM2[(I-1)+(I-1)*N],RV1[I-1],RV2[I-1]);
_200:
   end;
{      POBEPKA BEKTOPA  HOPMA }
  ITS := ITS + 1;
  NORM := 0.0;
  NORMV := 0.0;
  for I:=1 to UK do
   begin
    X := AA01C(RV1[I-1],RV2[I-1]);
    if ( NORMV >=  X ) 
     then goto _210;
    NORMV := X;
    J := I;
_210:
    NORM := NORM + X;
_220:
   end;
  if ( NORM <  GROWTO ) 
   then goto _240;
{      PEMEM BEKTOP }
  X := RV1[J-1];
  Y := RV2[J-1];
  for I:=1 to UK do
   begin
    AA02C(RV1[I-1],RV2[I-1],X,Y,ZR[(I-1)+(S-1)*NM],ZI[(I-1)+(S-1)*NM]);
_230:
   end;
  if ( UK =  N ) 
   then goto _290;
  J := UK + 1;
  goto _270;
{      OCTPOEHE HOBOO HAAHOO BEKTOPA }
_240:
  if ( ITS >=  UK ) 
   then goto _260;
  X := UKROOT;
  Y := EPS3/(X + 1.0);
  RV1[0] := EPS3;
  for I:=2 to UK do
   begin
    RV1[I-1] := Y;
_250:
   end;
  J := UK - ITS + 1;
  RV1[J-1] := RV1[J-1] - EPS3*X;
  goto _170;
{      MEHEHE IERR }
_260:
  J := 1;
  IERR := -K;
{      PCBABAHE OCTAHM KOMOHEHTAM BEKTOPA HAEH HY }
_270:
  for I:=J to N do
   begin
    ZR[(I-1)+(S-1)*NM] := 0.0;
    ZI[(I-1)+(S-1)*NM] := 0.0;
_280:
   end;
_290:
  S := S + 1;
_300:
 end;
goto _320;
_310:
if ( IERR <>  0 ) 
 then IERR := IERR - N;
if ( IERR =  0 ) 
 then IERR := -(2*N + 1);
_320:
M := S - 1;
if ( IERR <>  0 ) 
 then UTAE12(IERR,N,11);
end;

end.
